

; #########################################################################
.NOLIST
.386                      ; force 32 bit code
	.model flat, stdcall      ; memory model & calling convention
	option casemap :none      ; case sensitive
	include macro.inc
	include \masm32\include\windows.inc
	LIB kernel32,user32,masm32,advapi32

	Parametre PROTO :DWORD
	;pas a jour dans windows.inc OSVERSIONINFOEX , traducteur EDITMASM
EOSVERSIONINFOEX	STRUCT
	dwOSVersionInfoSize DWORD ?
	dwMajorVersion DWORD ?
	dwMinorVersion DWORD ?
	dwBuildNumber DWORD ?
	dwPlatformId DWORD ?
	szCSDVersion BYTE 128 dup (?)  ; Maintenance string for PSS usage
	wServicePackMajor WORD ?
	wServicePackMinor WORD ?
	wSuiteMask WORD ?
	wProductType BYTE ?
	wReserved BYTE ?

EOSVERSIONINFOEX		ENDS	
	
.data
	espace db " ",0
	point db ".",0
.code
	start:
	invoke Parametre,NULL
		
	invoke ExitProcess,NULL

;################################################################
Parametre PROC  bidule:DWORD 
			Local osvi:EOSVERSIONINFOEX
			Local  phrase[MAX_PATH+1]:BYTE
			LOcal  asciiC[20]:BYTE
			Local  case:DWORD
         		LOCAL hKey:DWORD,lRet,dwBufLen,bOsVersionInfoEx 
         		LOCAL szProductType[80]:BYTE
			Local  retour:DWORD
			ZEROLOCALES retour
			
	mov dwBufLen,sizeof szProductType
			
	mov osvi.dwOSVersionInfoSize,sizeof OSVERSIONINFOEXA
	;OSVERSIONINFOEX == OSVERSIONINFO +wServicePackMajor + wServicePackMinor +
	;        wReserved 2 word
	invoke GetVersionEx,addr osvi
	.if eax == FALSE
		mov osvi.dwOSVersionInfoSize,sizeof OSVERSIONINFO
		invoke GetVersionEx,addr osvi
		.if eax == FALSE
			mov osvi.dwOSVersionInfoSize,0
			jmp FindeParametre
		.endif
	.else
		mov bOsVersionInfoEx,eax
	.endif
	;dbut des tests
	PuPo case,osvi.dwPlatformId
	.if case == VER_PLATFORM_WIN32_NT
		.if osvi.dwPlatformId == 5 && osvi.dwMinorVersion == 2
			invoke lstrcat,addr phrase,SADR("Microsoft Windows Server 2003, ")
		.elseif osvi.dwMajorVersion == 5 && osvi.dwMinorVersion == 1
			invoke lstrcat,addr phrase,SADR("Microsoft Windows XP ")
		.elseif osvi.dwMajorVersion == 5 && osvi.dwMinorVersion == 0
			invoke lstrcat,addr phrase,SADR("Microsoft Windows 2000 ")
		.elseif osvi.dwMajorVersion <= 4
			invoke lstrcat,addr phrase,SADR("Microsoft Windows NT ")
		.endif
		; Test for specific product on Windows NT 4.0 SP6 and later.
		.if bOsVersionInfoEx 		
			;workstation ou server
			.if osvi.wProductType == VER_NT_WORKSTATION
				; Test for the workstation type.
				.if osvi.dwMajorVersion == 4
					invoke lstrcat,addr phrase,SADR("Workstation 4.0 ")
				.elseif osvi.wSuiteMask & VER_SUITE_PERSONAL
					invoke lstrcat,addr phrase,SADR("Home Edition ")
				.else				
					invoke lstrcat,addr phrase,SADR("Professional ")
				.endif
			.elseif osvi.wProductType == VER_NT_SERVER || osvi.wProductType == VER_NT_DOMAIN_CONTROLLER
				;Test for the server type
				.if osvi.dwMajorVersion==5 && osvi.dwMinorVersion==0
					.if osvi.wSuiteMask & VER_SUITE_DATACENTER
						invoke lstrcat,addr phrase,SADR("Datacenter Edition ")
					.elseif osvi.wSuiteMask & VER_SUITE_ENTERPRISE
						invoke lstrcat,addr phrase,SADR("Enterprise Edition ")
					.elseif osvi.wSuiteMask == VER_SUITE_BLADE
						invoke lstrcat,addr phrase,SADR("Web Edition ")
					.else
						invoke lstrcat,addr phrase,SADR("Standard Edition ")
					.endif
				.elseif osvi.dwMajorVersion==5 && osvi.dwMinorVersion==0
					.if osvi.wSuiteMask && VER_SUITE_DATACENTER
						invoke lstrcat,addr phrase,SADR("Datacenter Server ")
					.elseif osvi.wSuiteMask && VER_SUITE_ENTERPRISE
						invoke lstrcat,addr phrase,SADR("Advanced Server ")
					.else
						invoke lstrcat,addr phrase,SADR("Server ")
					.endif
				.else	
					;windows NT 4.0
					.if osvi.wSuiteMask & VER_SUITE_ENTERPRISE
						invoke lstrcat,addr phrase,SADR("Server 4.0, Enterprise Edition ")
					.else
						invoke lstrcat,addr phrase,SADR("Server 4.0 ")
					.endif
					
				.endif
				;Test for specific product on Windows NT 4.0 SP5 and earlier
				;fin de server
				
			.endif
			;fin de workstation ou server	
		.else		;bOsVersionInfoEx == 0  OSVERSIONINFO
			invoke RegOpenKeyEx, HKEY_LOCAL_MACHINE,SADR("SYSTEM\\CurrentControlSet\\Control\\ProductOptions"),\
					0, KEY_QUERY_VALUE, addr hKey
			.if eax != ERROR_SUCCESS
				jmp FindeParametre
			.endif
			invoke RegQueryValueEx,hKey,SADR("ProductType"), NULL, NULL,
					addr szProductType, addr dwBufLen
			.if eax != ERROR_SUCCESS || dwBufLen > sizeof szProductType
				jmp FindeParametre
			.endif
			invoke RegCloseKey,hKey
			invoke lstrcmpi,SADR("WINNT"),addr szProductType
			.if eax == 0
				invoke lstrcat,addr phrase,SADR(" Workstation ")
			.endif
			invoke lstrcmpi,SADR("LANMANNT"),addr szProductType
			.if eax == 0
				invoke lstrcat,addr phrase,SADR(" Server ")
			.endif
			invoke lstrcmpi,SADR("SERVERNT"),addr szProductType
			.if eax == 0
				invoke lstrcat,addr phrase,SADR(" Advanced Server ")
				invoke dwtoa,osvi.dwMajorVersion,addr asciiC
				invoke lstrcat,addr phrase,addr asciiC
				invoke lstrcat,addr phrase,addr point
				invoke dwtoa,osvi.dwMinorVersion,addr asciiC
				invoke lstrcat,addr phrase,addr asciiC			
			.endif
			
		.endif	;bOsVersionInfoEx
		
		;HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows NT\CurrentVersion
		;-----------  Display service pack (if any) and build number. ---------------
		invoke lstrcmpi,addr osvi.szCSDVersion,SADR("Service Pack 6")
		.if eax == 0 && osvi.dwMajorVersion == 4
			;Test for SP6 versus SP6a 
			invoke RegOpenKeyEx,HKEY_LOCAL_MACHINE,SADR("SOFTWARE\\Microsoft\\Windows NT\\CurrentVersion\\Hotfix\\Q246009"),
					0, KEY_QUERY_VALUE,addr hKey
			.if eax == ERROR_SUCCESS
				invoke lstrcat,addr phrase,SADR("Service Pack 6a Build ")
				mov edx,osvi.dwBuildNumber
				and edx,0FFFFh
				invoke dwtoa,edx,addr asciiC
				invoke lstrcat,addr phrase,addr asciiC
			.else	;Windows NT 4.0 prior to SP6a
				invoke lstrcat,addr phrase,SADR("Build ")		
				invoke lstrcat,addr phrase,addr osvi.szCSDVersion
				invoke lstrcat,addr phrase,addr espace
				mov edx,osvi.dwBuildNumber 
				and edx, 0FFFFh
				invoke dwtoa,edx,addr asciiC
				invoke lstrcat,addr phrase,addr asciiC
			.endif
			invoke RegCloseKey,hKey
		.else	;not Windows NT 4.0
			invoke lstrcat,addr phrase,SADR("Build ")
			invoke lstrcat,addr phrase,addr osvi.szCSDVersion
			invoke lstrcat,addr phrase,addr espace		
			mov edx,osvi.dwBuildNumber 
			and edx, 0FFFFh
			invoke dwtoa,edx,addr asciiC
			invoke lstrcat,addr phrase,addr asciiC
		.endif
	;Test for the Windows Me/98/95
	.elseif case  == VER_PLATFORM_WIN32_WINDOWS
		.if osvi.dwMajorVersion == 4 && osvi.dwMinorVersion == 0
			invoke lstrcpy,addr phrase,SADR("Microsoft Windows 95 ")
			.if byte ptr osvi.szCSDVersion =="C" || byte ptr osvi.szCSDVersion == "B"
				invoke lstrcat,addr phrase,SADR("OSR2 ")
			.endif
		.elseif osvi.dwMajorVersion == 4 && osvi.dwMinorVersion == 10
			invoke lstrcpy,addr phrase,SADR("Microsoft Windows 98 ")
			.if byte ptr osvi.szCSDVersion == "A"
				invoke lstrcat,addr phrase,SADR("SE ")
			.endif
		.elseif osvi.dwMajorVersion == 4 && osvi.dwMinorVersion == 90
			invoke lstrcpy,addr phrase,SADR("Microsoft Windows Millennium Edition")
		.endif
	.elseif case  == VER_PLATFORM_WIN32s
		invoke lstrcpy,addr phrase,SADR("Microsoft Win32s")
	.endif
	;------------------------------------------------------------------------------------	
	invoke MessageBox,NULL,addr phrase,SADR("OS version"),MB_OK			
	mov retour,1
 FindeParametre:
         mov eax,retour
         ret
Parametre endp

;################################################################



.NOLIST

; #########################################################################

 end start